#pragma once

using namespace std;

#include <ostream>

class V3 {

  float xyz[3];
public:
  
  V3() {};
  V3(float x, float y, float z);
  friend ostream& operator<<(ostream& os, V3 v);
  float& operator[](int i);
  V3 operator+(V3 v1);
  V3 operator-(V3 v1);
  V3 operator^(V3 op1);
  float operator*(V3 v1);
  V3 operator/(float scf);
  V3 operator*(float scf);
  void SetFromColor(unsigned int color);
  unsigned int GetColor();
  float Length();
  V3 UnitVector();
};

class AABB {
public:
  V3 corners[2];
  AABB(V3 firstPoint);
  void AddPoint(V3 pt);
};

